#!/bin/sh
#
# Component: taskd
#
# Description:
#   Cleans up and removes tasks. Will call the cleanup methods of the tasks and remove them.
#
# Usage:
#    cleanupTask.sh taskfile ...
#
#
# Last Updated     : $Author$
# Update Date Time : $Date$
# RCS File Name    : $RCSfile$
# RCS Revision     : $Revision$
# Locked by        : $Locker$
# Symbolic name    : $Name$
# State            : $State$
#

. $HOME/etc/setenv.sh

[ -f "$TASKD_CONF" ] && . $TASKD_CONF

SoTaskList=""

while [ -n "$1" ] ; do
	TASKNAME="$1"
	if [ "${TASKNAME%.class}" != "${TASKNAME}" ] ; then
		echo "Java task"
		CMD=`cat ${TASKNAME}`
		echo "Task command:"$CMD		
		if [ -n "$CMD" ] ; then 
			$TASKD_HOME/runjavacmd -c "cleanup $CMD" -p ${JAVA_SERVER_PORT}
			retval=$?
			echo "returned:" $retval
			if [ $retval == 0 ] ; then 
				rm -f ${TASKNAME}
				echo "task ${TASKNAME} deleted"	
			else
				echo "cleanup failed, so task ${TASKNAME} was not deleted"
			fi 
		else
			echo "task ${TASKNAME} not found"
		fi	
	elif [ "${TASKNAME%.so}" != "${TASKNAME}" ] ; then
		SoTaskList="$SoTaskList ${TASKNAME}"
	else
		echo "Shellscript task"
		$TASKD_HOME/runshellcmd.sh -C -f ${TASKNAME}
		retval=$?
		echo "returned:" $retval
		if [ $retval == 0 ] ; then 
			rm -f ${TASKNAME}
			echo "task ${TASKNAME} deleted"	
		else
			echo "cleanup failed, so task ${TASKNAME} was not deleted"
		fi 
	fi

	shift
done

if [ -n "$SoTaskList" ] ; then
	$TASKD_HOME/runsocmd -C ${SoTaskList}
	rm -f ${SoTaskList}
fi
