#!/bin/sh
#
# Component: taskd
#
# Description:
#   Cleans up and removes tasks. Will call the cleanup methods of the tasks and remove them.
#
# Usage:TQTASKID:
#    cleanupTask.sh taskname... (taskname is TQNAME in the TaskQueue table)
#
#
# Last Updated     : $Author$
# Update Date Time : $Date$
# RCS File Name    : $RCSfile$
# RCS Revision     : $Revision$
# Locked by        : $Locker$
# Symbolic name    : $Name$
# State            : $State$
#

. $HOME/etc/setenv.sh

[ -f "$TASKD_CONF" ] && . $TASKD_CONF

SoTaskList=""

while [ -n "$1" ] ; do
	TASKNAME="$1"
	
	#check Q first
	CHECK="select TQQUEUE from TaskQueue where TQNAME='$1'"
	Q=`echo "$CHECK;" | $MYSQL_HOME/bin/mysql -N $DBNAME`
	if [ "$Q" == "scheduled" ] || [ "$Q" == "running" ] || [ "$Q" == "retry" ] || [ "$Q" == "delay" ] || [ "$Q" == "future" ] || [ "$Q" == "unprocessed" ] ; then
		echo "NOT allowed to run on task in the Queue '$Q', task is:  $1 ! - Skipped"
	else	 
	    QUERY="select (case when ( LOCATE( '\n', TQCONTENT)=0 ) then TQCONTENT else SUBSTRING( TQCONTENT, 1, LOCATE( '\n', TQCONTENT)-1) end ) from TaskQueue where TQNAME='$1'"
#		QUERY="select trim('\\n' from TQCONTENT) from TaskQueue where TQNAME='$1'"
		CMD=`echo "$QUERY;" | $MYSQL_HOME/bin/mysql -N $DBNAME`
		echo "Task command:"$CMD		
		if [ -n "$CMD" ] ; then 
			if [[ "${TASKNAME}" == *"class"* ]]; then
				#Java
				echo "Java task"
				$TASKD_HOME/runjavacmd -c "cleanup $CMD" -p ${JAVA_SERVER_PORT}
				retval=$?
				echo "returned:" $retval
			else
				#shellscript
				echo "Shellscript task"
				$TASKD_HOME/runshellcmd.sh -C $CMD
				retval=$?
				echo "returned:" $retval
			fi
			if [ $retval == 0 ] ; then 
				sql.sh "delete from TaskQueue where TQNAME='$1'"
				echo "task ${TASKNAME} deleted"
			else
				echo "cleanup failed, so task ${TASKNAME} was not deleted"
			fi
		else
			echo "task ${TASKNAME} not found"
		fi	
	fi
	shift
done

